/*************************************
 * This example is from https://github.com/Kongduino/RUI3_LoRa_P2P_PING_PONG
 * This example needs two devices, a device will send LoRa P2P package after receiving LoRa P2P package.
 *************************************/
extern const char *sw_version;

long startTime;
bool rx_done = false;
uint8_t set=0;
double myFreq = 921000000;

uint16_t sf = 7, bw = 0, cr = 0, preamble = 8, txPower = 5;
uint8_t ledPin1 = LED_GREEN;
uint8_t ledPin2 = LED_BLUE;
uint8_t IO1 = LED_GREEN;//WB_IO1
uint8_t IO2 = LED_BLUE; //WB_IO2
uint8_t IO3 = WB_TXD0;//PB6 WB_TXD0//WB_TXD1 dame?


rt rtserial;

void recv_cb(rui_lora_p2p_recv_t data)
{
    char buff[100]="";
    char *temp;
    

    bool send_result = false;    
    int itemp;
    rx_done = true;
    if (data.BufferSize == 0) {
        Serial.println("Empty buffer.");
        //Serial.printf("P2P set Rx mode %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");        //2重に送るとエラーになるから
        return;
    }
    sprintf(buff, "Incoming message, length: %d, RSSI: %d, SNR: %d",data.BufferSize, data.Rssi, data.Snr);
    Serial.println(buff);
    
    strncpy(buff, (char*)data.Buffer,data.BufferSize);
    buff[data.BufferSize]='\0';
    Serial.print(buff);//受信PCにスルーさせる

    if(!strncmp(buff, "8:", 2)){
      Serial.println("data is 8");
      strtok(buff, ":");
      strtok(NULL, ",");//loraNo
      temp = strtok(NULL, ",");//区分
      Serial.println(temp);

      if(!strncmp(temp, "1S", 2)){
        digitalWrite(IO1, LOW);
        digitalWrite(IO2, LOW);
        digitalWrite(IO3, LOW);
      }
      if(!strncmp(temp, "2S", 2)){
        digitalWrite(IO1, HIGH);
        digitalWrite(IO2, LOW);
        digitalWrite(IO3, LOW);        
      }
      if(!strncmp(temp, "3S", 2)){
        digitalWrite(IO1, LOW);
        digitalWrite(IO2, HIGH);
        digitalWrite(IO3, LOW);        
      }

 
    }
}

void send_cb(void)
{
   //Serial.printf("P2P set Rx mode %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");
}

void setup()
{
    pinMode(IO1, OUTPUT);
    pinMode(IO2, OUTPUT);
    pinMode(IO3, OUTPUT);
    digitalWrite(IO1, LOW);
    digitalWrite(IO2, LOW);
    digitalWrite(IO3, LOW);


    Serial.begin(115200);
    Serial.println("RAKwireless LoRaP2P jusinki wintablet_v2_kyoutu_jikan");
    Serial.println("-----------------------");
    delay(2000);
    startTime = millis();
    
    if(api.lorawan.nwm.get() != 0)
    {
        Serial.printf("Set Node device work mode %s\r\n",
            api.lorawan.nwm.set(0) ? "Success" : "Fail");
        api.system.reboot();
    }

    Serial.println("P2P Start");
    Serial.printf("Hardware ID: %s\r\n", api.system.chipId.get().c_str());
    Serial.printf("Model ID: %s\r\n", api.system.modelId.get().c_str());
    Serial.printf("RUI API Version: %s\r\n",
  		api.system.apiVersion.get().c_str());
//    Serial.printf("Firmware Version: %s\r\n",	api.system.firmwareVersion.get().c_str());
    Serial.printf("Firmware Version: %s\r\n",sw_version);
    Serial.printf("AT Command Version: %s\r\n",
  		api.system.cliVersion.get().c_str());
    Serial.printf("Set P2P mode frequency %3.3f: %s\r\n", (myFreq / 1e6),
  		api.lorawan.pfreq.set(myFreq) ? "Success" : "Fail");
    Serial.printf("Set P2P mode spreading factor %d: %s\r\n", sf,
  		api.lorawan.psf.set(sf) ? "Success" : "Fail");
    Serial.printf("Set P2P mode bandwidth %d: %s\r\n", bw,
  		api.lorawan.pbw.set(bw) ? "Success" : "Fail");
    Serial.printf("Set P2P mode code rate 4/%d: %s\r\n", (cr + 5),
  		api.lorawan.pcr.set(cr) ? "Success" : "Fail");
    Serial.printf("Set P2P mode preamble length %d: %s\r\n", preamble,
  		api.lorawan.ppl.set(preamble) ? "Success" : "Fail");
    Serial.printf("Set P2P mode tx power %d: %s\r\n", txPower,
  		api.lorawan.ptp.set(txPower) ? "Success" : "Fail");
    api.lorawan.registerPRecvCallback(recv_cb);
    api.lorawan.registerPSendCallback(send_cb);
    Serial.printf("P2P set precv65533 %s\r\n",api.lorawan.precv(65533) ? "Success" : "Fail");

  // RT_INIT(&rtserial);
}

void serial_read_line(char buf[], int n){
  int i = 0, input;
  
  while(1){
    input = Serial.read();
    if ( input == -1 ) continue;
    if ( input == int('\n') ) {
      buf[i] = '\0';
      return;
    }
    buf[i] = input;
    i++;
    if ( i >= n-1 ) {
      buf[n-1] = '\0';
      return;
    }
  }
}
/*
int serialThread(struct rt *rt) {
  char str[75]="";
  bool send_result = false;

    RT_BEGIN(rt);

    for (;;) {
      send_result = false;      
      if (Serial.available() > 0) {   //送信PCしりあるから、受信したデータが存在する
        serial_read_line(str,75);
        while (!send_result) {//psend失敗してる間は
          send_result = api.lorawan.psend(strlen(str),(uint8_t*)str);//loraで送信
            Serial.printf("P2P send %s\r\n", send_result ? "Success" : "Fail");
        }
      }
    }

    RT_END(rt);
}
*/

void loop()
{
  
  char str[75]="";
  uint8_t count = 0;
  bool send_result = false;
  uint8_t No = 0;

  if (Serial.available() > 0) {   //送信PCしりあるから、受信したデータが存在する
    serial_read_line(str,75);
    while (!send_result) {//psend失敗してる間は
       send_result = api.lorawan.psend(strlen(str),(uint8_t*)str);//loraで送信
        Serial.printf("P2P send %s\r\n", send_result ? "Success" : "Fail");
    }
  }

   //    delay(10);//dame ms
     api.system.sleep.all(100);//ms

   // RT_SCHEDULE(serialThread(&rtserial));
}
